=== modified file 'clean_tree.py'
--- clean_tree.py	2005-10-17 12:34:42 +0000
+++ clean_tree.py	2005-10-17 12:41:13 +0000
@@ -23,17 +23,17 @@
     return subp.endswith('.THIS') or subp.endswith('.BASE') or\
         subp.endswith('.OTHER') or subp.endswith('~') or subp.endswith('.tmp')
 
-def iter_deletables(tree, unknowns=True, ignored=False, detrius=False):
+def iter_deletables(tree, unknown=True, ignored=False, detrius=False):
     """Iterate through files that may be deleted"""
     for subp in tree.extras():
-        if is_detrius(subp):
+        if detrius and is_detrius(subp):
             yield tree.abspath(subp), subp
             continue
         if tree.is_ignored(subp):
             if ignored:
                 yield tree.abspath(subp), subp
         else:
-            if unknowns:
+            if unknown:
                 yield tree.abspath(subp), subp
 
 def clean_tree(directory, ignored=False, detrius=False, dry_run=False):
@@ -80,5 +80,19 @@
             tree = b.working_tree()
             file('branch/file.BASE', 'wb').write('contents')
             self.assertEqual(len(list(iter_deletables(tree))), 1)
-            
+            file('branch/file~', 'wb').write('contents')
+            file('branch/file.pyc', 'wb').write('contents')
+            dels = [r for a,r in iter_deletables(tree)]
+            assert 'file~' not in dels
+            assert 'file.pyc' not in dels
+            dels = [r for a,r in iter_deletables(tree, detrius=True)]
+            assert 'file~' in dels
+            assert 'file.pyc' not in dels
+            dels = [r for a,r in iter_deletables(tree, ignored=True)]
+            assert 'file~' in dels
+            assert 'file.BASE' in dels
+            assert 'file.pyc' in dels
+            dels = [r for a,r in iter_deletables(tree, unknown=False)]
+            assert 'file.BASE' not in dels
+
     return makeSuite(TestCleanTree)

